offensive *create_explosion(float red, float green, float blue, global *g_point, vector position, int strength, int type)
{
	offensive *o=malloc(sizeof(offensive));

	o->type=EXPLOSION;
	o->shot_strength=strength;
	o->inherited_shot=strength;
	o->speed=g_point->shot_speed;
	o->position=position;
	o->red=red;
	o->green=green;
	o->blue=blue;
	o->dispersion=0;
	o->size=g_point->particle_size;
	o->type=type;

if (type==MINE_EXPLOSION)
	o->shot_strength*=1.2;

/*reorganize the pointers*/

	if(g_point->first_explosion)					//if not first in explosion in row
		{
		o->prev=g_point->last_explosion;
		g_point->last_explosion->next=o;
		}
	else
		{
		g_point->first_explosion=o;
		o->prev=0;
		}
	o->next=0;
	g_point->last_explosion=o;

	return o;


}

void remove_explosion (offensive *current, global *g_point)
	{

	offensive *prev=current->prev;				//the prev and next pointers are void *
	offensive *next=current->next;

	if (prev==0)						//if this is the first explosion in the row
			{
			next->prev=0;						// make the next player the first in row
			g_point->first_explosion=next;		//udate the global start of player list
			}
	else
		if (next==0)
				{						//if this is the last player in the row
				prev->next=0;					//make the prev player the last in row
				g_point->last_explosion=prev;
				}
			else
				{								//make the surrounding explosions point at eachother
				next->prev=current->prev;
				prev->next=current->next;
				}
free(current);
	}






void update_explosion(offensive *current, global *g_point, int counter)
	{
	if (current->shot_strength>=0)
		{current->shot_strength--;
		current->size+=0.0025;}
	else
		{
			remove_explosion (current, g_point);
			return;
		}

			float intensity=((float)current->shot_strength/(float)current->inherited_shot);

			float intensity2=0.25f;

			current->dispersion+=intensity*0.25f;

			float disp=current->dispersion;
			float size=current->size;

			glLoadIdentity();					// Reset The View

			glTranslatef(current->position.X,current->position.Y,-22.0f+counter*0.001);		// Move Left to current position And Into The Screen

			int i;

		 	glBegin(GL_QUADS);					// start drawing a polygon

		for ( i=0; i<=17;i++)
			{
			glRotatef(PI_32,0.0f,0.0f,1.0f);

				glColor4f(current->red, current->green,current->blue ,intensity2);
  				glVertex3f(-size+disp,size, 0.5f);		// Top left
 				glColor4f(current->red, current->green,current->blue ,intensity);
				glVertex3f( size+disp,size, 0.5f);		// Top right
				glVertex3f( size+disp,-size, 0.5);		// Bottom Right
  				glColor4f(current->red, current->green,current->blue ,intensity2);
				glVertex3f(-size+disp,-size, 0.5f);		// Bottom Left


  				glColor4f(current->red, current->green,current->blue ,intensity);

  				glVertex3f(-size-disp,size, 0.5f);		// Top left
  				glColor4f(current->red, current->green,current->blue ,intensity2);
				glVertex3f( size-disp,size, 0.5f);		// Top right
				glVertex3f( size-disp,-size, 0.5f);		// Bottom Right
  				glColor4f(current->red, current->green,current->blue ,intensity);
				glVertex3f(-size-disp,-size, 0.5f);		// Bottom Left


  				glColor4f(current->red, current->green,current->blue ,intensity2);
  				glVertex3f(-size,size-disp, 0.5f);		// Top left
  				glVertex3f( size,size-disp, 0.5f);		// Top right
  				glColor4f(current->red, current->green,current->blue ,intensity);
				glVertex3f( size,-size-disp, 0.5f);		// Bottom Right
  				glVertex3f(-size,-size-disp, 0.5f);		// Bottom Left

  				glVertex3f(-size,size+disp, 0.5f);		// Top left
  				glVertex3f(size,size+disp, 0.5f);		// Top right
  				glColor4f(current->red, current->green,current->blue ,intensity2);
				glVertex3f(size,-size+disp, 0.5f);		// Bottom Right
  				glVertex3f(-size,-size+disp, 0.5);		// Bottom Left
			}

		}

void update_mine_explosion(offensive *current, global *g_point, int counter)
	{

	if (current->shot_strength>=0)
		{current->shot_strength--;
		current->size+=0.006;
		}
	else
		{
			remove_explosion (current, g_point);
			return;
		}

			float intensity=((float)current->shot_strength/(float)current->inherited_shot);

			current->dispersion+=intensity*0.25f;
			float disp=current->dispersion;
			float size=current->size;

			glLoadIdentity();					// Reset The View

			glTranslatef(current->position.X,current->position.Y,-22.0f+counter*0.001);		// Move Left to current position And Into The Screen

			int i;

			 	glBegin(GL_QUADS);					// start drawing a polygon

		for ( i=0; i<=7;i++)
			{
			glRotatef(PI_16,0.0f,0.0f,1.0f);

				glColor4f(current->red, current->green,current->blue ,intensity);
  				glVertex3f(-size+disp,size, 0.5f);		// Top left
  				glVertex3f( size+disp,size, 0.5f);		// Top right
				glVertex3f( size+disp,-size, 0.5);		// Bottom Right
  				glVertex3f(-size+disp,-size, 0.5f);		// Bottom Left

				glVertex3f(-size-disp,size, 0.5f);  // Top left
  				glVertex3f( size-disp,size, 0.5f);		// Top right
				glVertex3f( size-disp,-size, 0.5f);		// Bottom Right
  				glVertex3f(-size-disp,-size, 0.5f);		// Bottom Left

				glVertex3f(-size,size-disp, 0.5f);		// Top left
  				glVertex3f( size,size-disp, 0.5f);		// Top right
				glVertex3f( size,-size-disp, 0.5f);		// Bottom Right
  				glVertex3f(-size,-size-disp, 0.5f);		// Bottom Left

  				glVertex3f(-size,size+disp, 0.5f);		// Top left
  				glVertex3f(size,size+disp, 0.5f);		// Top right
				glVertex3f(size,-size+disp, 0.5f);		// Bottom Right
  				glVertex3f(-size,-size+disp, 0.5);		// Bottom Left
			}
  									// we're done with the polygon (smooth color interpolation)

		}


void update_explosions(global *g_point)		//calculates movement of players and collision with passives and other players,then draw
	{

	int counter=0;

	offensive *current=g_point->first_explosion;

		while(current)
			{

			if (current->type==MINE_EXPLOSION)
				update_mine_explosion(current, g_point, counter);
			else
				update_explosion(current, g_point, counter);


			current=current->next;
			counter++;
			}


colour mist=g_point->mist;

mist.red-=MIST_C_DECREASE;
mist.green-=MIST_C_DECREASE;
mist.blue-=MIST_C_DECREASE;
mist.alpha-=g_point->mist_a_decrease;

if (mist.alpha<0.0)
	mist.alpha=0.0f;

if (mist.alpha>g_point->mist_max_a)
	mist.alpha=g_point->mist_max_a;

if (mist.red<0.0)
	mist.red=0.0f;

if (mist.red>2.0)
	mist.red=2.0f;

if (mist.green<0.0)
	mist.green=0.0f;

if (mist.green>2.0)
	mist.green=2.0f;

if (mist.blue<0.0)
	mist.blue=0.0f;

if (mist.blue>2.0)
	mist.blue=2.0f;

			glLoadIdentity();					// Reset The View
			 	glBegin(GL_QUADS);					// start drawing a polygon
				glColor4f(mist.red, mist.green,mist.blue,mist.alpha);
				glVertex3f(-1.3f,1, 0.1);		// Top left
				glVertex3f(1.3,1, 0.1);		// Top right
				glVertex3f(1.3,-1, 0.1);		// Bottom Right
  				glVertex3f(-1.3,-1, 0.1);		// Bottom Left

g_point->mist=mist;

	}
