/*prototypes*/

float mine_player_collision(mine *current, player *target);

offensive *create_mine_offensive(mine *orign, global *g_point, float orientation, int type);



mine *create_mine(player *orign, global *g_point)
	{
/*start with a test to see if the mine is about to be spawned within an existing one*/

vector tmp, distance;

tmp.X=orign->position.X-(fsin(orign->orientation)*(orign->size+MINE_SIZE+0.1f));
tmp.Y=orign->position.Y-(fcos(orign->orientation)*(orign->size+MINE_SIZE+0.1f));


float mine_radi=MINE_SIZE*MINE_SIZE*4;

mine *existing_mine=g_point->first_mine;


while(existing_mine)
	{
	distance.X=tmp.X-existing_mine->position.X;
	distance.Y=tmp.Y-existing_mine->position.Y;
	if (((distance.X*distance.X)+(distance.Y*distance.Y))<mine_radi)
		{
		orign->button.b++;
		return 0;
		}
	existing_mine=existing_mine->next;
	}

/*if they aren't going to share position*/

	mine *m=malloc(sizeof(mine));
	m->source=orign;
	m->position=tmp;
	m->countdown=g_point->mine_countdown;
	m->pulse=MINE_PULSE_RATE;
	m->red=orign->red;
	m->green=orign->green;
	m->blue=orign->blue;
	m->size=MINE_SIZE;
	m->collision=1;

if (orign->button.b<=MINE_PULSE_RATE)
	{
	m->velocity.X=0.0f;
	m->velocity.Y=0.0f;
	play_sfx(sound.mine_deploy, 128, pos2pan(m->position.X), g_point);
	}
else
	{
	m->velocity.X=orign->velocity.X*0.9f;
	m->velocity.Y=orign->velocity.Y*0.9f;
	play_sfx(sound.mine_slide, 128, pos2pan(m->position.X), g_point);
	}

	orign->button.b=0;

/*reorganize the pointers*/

	if(g_point->first_mine)					//if not first mine in row
		{
		m->prev=g_point->last_mine;
		g_point->last_mine->next=m;
		}
	else
		{
		g_point->first_mine=m;
		m->prev=0;
		}
	m->next=0;
	g_point->last_mine=m;

	return m;
	}

void remove_mine (mine *obj, global *g_point)
	{
	float inc=0;
	while (inc<PI2)
		{
		create_mine_offensive(obj, g_point, inc, MINE_EXPLOSION);
		inc+=PI_16;
		}

	mine *prev=obj->prev;				//the prev and next pointers are void *
	mine *next=obj->next;


	if (prev==0)						//if this is the first offensive in the row
			{
			next->prev=0;						// make the next mine the first in row
			g_point->first_mine=next;		//udate the global start of mine list
			}
	else
		if (next==0)
				{						//if this is the last player in the row
				prev->next=0;					//make the prev player the last in row
				g_point->last_mine=prev;
				}
			else
				{								//make the surrounding mines point at eachother
				next->prev=obj->prev;
				prev->next=obj->next;
				}
free(obj);
	}



void update_mine(mine *current, global *g_point)

	{

mine carbon;

memcpy(&carbon, current, sizeof(mine));

	if (carbon.countdown)
		current->countdown--;
	else
		{
		play_sfx(sound.mine_pop, 255, pos2pan(carbon.position.X), g_point);
		remove_mine (current, g_point);
		return;
		}

if (!carbon.pulse)
	current->pulse=MINE_PULSE_RATE;
else
	current->pulse--;

	player *target=g_point->first_player;												//check for collison with player;

		while (target)
			{
			if (!target->knocked_out)
				{
				if (mine_player_collision(current,target)>0)
					{
					remove_mine(current, g_point);
					play_sfx(sound.mine_pop, 255, pos2pan(target->position.X), g_point);

							glLoadIdentity();					// Reset The View

		float size=carbon.size;

		glTranslatef(carbon.position.X,carbon.position.Y,-22.0f);		// Move Left to current position And Into The Screen

		float pulse=((float)carbon.pulse/MINE_PULSE_RATE)+0.2f;

 	 	glColor3f(carbon.red*pulse,carbon.green*pulse,carbon.blue*pulse);

 	 	glBegin(GL_QUADS);					// start drawing a polygon
  		glVertex3f(-0.5f*size, 1.0f*size, 0.0f);		// Top left
  		glVertex3f( 0.5f*size, 1.0f*size, 0.0f);		// Top right
  		glVertex3f( 1.0f*size, 0.0f*size, 0.0f);		// Bottom Right
  		glVertex3f(-1.0f*size,-0.0f*size, 0.0f);		// Bottom Left

  		glVertex3f(-1.0f*size, 0.0f*size, 0.0f);		// Top left
  		glVertex3f( 1.0f*size, 0.0f*size, 0.0f);		// Top right
  		glVertex3f( 0.5f*size, -1.0f*size, 0.0f);		// Bottom Right
  		glVertex3f(-0.5f*size,-1.0f*size, 0.0f);		// Bottom Left

		float size2=size*(((float)carbon.countdown/g_point->mine_countdown-1.0f)*-1.0f)*0.9;

pulse=size2*0.7;

  	glColor3f(carbon.red*pulse,carbon.green*pulse,carbon.blue*pulse);

  		glVertex3f(-0.5f*size2, 1.0f*size2, 0.01f);		// Top left
  		glVertex3f( 0.5f*size2, 1.0f*size2, 0.01f);		// Top right
  		glVertex3f( 1.0f*size2, 0.0f*size2, 0.01f);		// Bottom Right
  		glVertex3f(-1.0f*size2,-0.0f*size2, 0.01f);		// Bottom Left

  		glVertex3f(-1.0f*size2, 0.0f*size2, 0.01f);		// Top left
  		glVertex3f( 1.0f*size2, 0.0f*size2, 0.01f);		// Top right
  		glVertex3f( 0.5f*size2, -1.0f*size2, 0.01f);		// Bottom Right
  		glVertex3f(-0.5f*size2,-1.0f*size2, 0.01f);		// Bottom Left




					return;
					}
				}
			target=target->next;
			}


mine *mine=carbon.next;

while(mine)
	{
	mine_mine_collision(current, mine, g_point);

	mine=mine->next;
	}

if (current->collision)
	current->collision=FALSE;

else
	{
	current->position.X+=current->velocity.X;
	current->position.Y+=current->velocity.Y;
	}


		if (current->position.X>32.0f)
			current->position.X-=64.0f;
		else
		if (current->position.X<-32.0f)
			current->position.X+=64.0f;

		if (current->position.Y>24.0f)
			current->position.Y-=48.0f;
		else
		if (current->position.Y<-24.0f)
			current->position.Y+=48.0f;


		glLoadIdentity();					// Reset The View

		float size=current->size;

		glTranslatef(current->position.X,current->position.Y,-22.0f);		// Move Left to current position And Into The Screen

		float pulse=((float)current->pulse/MINE_PULSE_RATE)+0.2f;

 	 	glColor3f(current->red*pulse,current->green*pulse,current->blue*pulse);

 	 	glBegin(GL_QUADS);					// start drawing a polygon
  		glVertex3f(-0.5f*size, 1.0f*size, 0.0f);		// Top left
  		glVertex3f( 0.5f*size, 1.0f*size, 0.0f);		// Top right
  		glVertex3f( 1.0f*size, 0.0f*size, 0.0f);		// Bottom Right
  		glVertex3f(-1.0f*size,-0.0f*size, 0.0f);		// Bottom Left

 	 	glBegin(GL_QUADS);					// start drawing a polygon
  		glVertex3f(-1.0f*size, 0.0f*size, 0.0f);		// Top left
  		glVertex3f( 1.0f*size, 0.0f*size, 0.0f);		// Top right
  		glVertex3f( 0.5f*size, -1.0f*size, 0.0f);		// Bottom Right
  		glVertex3f(-0.5f*size,-1.0f*size, 0.0f);		// Bottom Left

		float size2=size*(((float)current->countdown/g_point->mine_countdown-1.0f)*-1.0f)*0.9;

pulse=size2*0.7;

  	glColor3f(current->red*pulse,current->green*pulse,current->blue*pulse);
	//glColor3f(0.0f,0.0f,0.0f);


	 	 	glBegin(GL_QUADS);					// start drawing a polygon
  		glVertex3f(-0.5f*size2, 1.0f*size2, 0.01f);		// Top left
  		glVertex3f( 0.5f*size2, 1.0f*size2, 0.01f);		// Top right
  		glVertex3f( 1.0f*size2, 0.0f*size2, 0.01f);		// Bottom Right
  		glVertex3f(-1.0f*size2,-0.0f*size2, 0.01f);		// Bottom Left

 	 	glBegin(GL_QUADS);					// start drawing a polygon
  		glVertex3f(-1.0f*size2, 0.0f*size2, 0.01f);		// Top left
  		glVertex3f( 1.0f*size2, 0.0f*size2, 0.01f);		// Top right
  		glVertex3f( 0.5f*size2, -1.0f*size2, 0.01f);		// Bottom Right
  		glVertex3f(-0.5f*size2,-1.0f*size2, 0.01f);		// Bottom Left


	}


void update_mines(global *g_point)			//calculates movement of players and collision with passives and other players,then draw
	{

	mine *current=g_point->first_mine;

	if (current==0)
		return;
		do
			{
			update_mine(current, g_point);


			current=current->next;

			}

		while (current);
	}


float mine_player_collision(mine *current, player *target)
{
/*collision code is almost copy'n'paste from http://www.gamasutra.com/features/20020118/vandenhuevel_02.htm*/

/*begin conversion from polar to rectangular coordinates*/

if (target->type==BLUE && !target->bouncing)
	{
	vector tmp;
	tmp.X=-(fcos(target->orientation+PI_2)*target->speed);
	tmp.Y=(fsin(target->orientation+PI_2)*target->speed);
	target->velocity=tmp;
	}

/*end conversion from polar to rectangular coordinates*/


/*distance vector between the two objects*/
vector C;
C.X=target->position.X-current->position.X;
C.Y=target->position.Y-current->position.Y;

/*velocity vector for the relative movement of the two objects*/
vector V;
V.X=current->velocity.X-target->velocity.X;
V.Y=current->velocity.Y-target->velocity.Y;

/*early escape 1, is the relative velocity of the objects greater than the distance between them?*/


float v_length=fsqrt(V.X*V.X+V.Y*V.Y);

float sum_radi=(current->size+target->size);


float C_square=(C.X*C.X)+(C.Y*C.Y);

if(v_length<(fsqrt(C_square)-sum_radi))
	return -1;

if(v_length<=0.0000000f)
	v_length=0.0001;

/*normalizing the V vector*/

vector VN;

VN.X=V.X/v_length;
VN.Y=V.Y/v_length;

float D=C.X*VN.X+C.Y*VN.Y;

if (D<0)
	return -2;

float F_square=C_square-(D*D);

float sum_radi_square=sum_radi*sum_radi;

if (F_square>sum_radi_square)
	return -3;

float T_square=sum_radi_square-F_square;

D-=fsqrt(T_square);

if (D>v_length)
	return -4;

D/=v_length;

return 1;

}

offensive *create_mine_offensive(mine *orign, global *g_point, float orientation, int type)
	{
	offensive *o=malloc(sizeof(offensive));

	o->source=orign->source;
	o->type=MINE_EXPLOSION;
	o->shot_strength=g_point->mine_strength;
	o->speed=g_point->shot_speed*1.5f;
	o->orientation=orientation;
	o->position=orign->position;
	o->red=orign->red;
	o->green=orign->green;
	o->blue=orign->blue;
	o->size=0.08f;
	o->inherited_shot=0;

/*reorganize the pointers*/

	if(g_point->first_offensive)					//if not first in offensive in row
		{
		o->prev=g_point->last_offensive;
		g_point->last_offensive->next=o;
		}
	else
		{
		g_point->first_offensive=o;
		o->prev=0;
		}
	o->next=0;
	g_point->last_offensive=o;

	return o;


	};



int mine_mine_collision(mine *current, mine *target, global *g_point)
{
/*collision code is almost copy'n'paste from http://www.gamasutra.com/features/20020118/vandenhuevel_02.htm*/

/*distance vector between the two objects*/
vector C;
C.X=target->position.X-current->position.X;
C.Y=target->position.Y-current->position.Y;

/*velocity vector for  the relative movement of the two objects*/
vector V;
V.X=current->velocity.X-target->velocity.X;
V.Y=current->velocity.Y-target->velocity.Y;


/*early escape 1, is the relative velocity of the objects greater than the distance between them?*/

float v_length=fsqrt((V.X*V.X)+(V.Y*V.Y));

float sum_radi=(current->size+target->size);

float C_square=(C.X*C.X)+(C.Y*C.Y);

if(v_length<(fsqrt(C_square)-sum_radi))
	return -1;

	if(v_length<=0.00000000f)
		v_length=0.0001;


/*normalizing the V vector*/

vector VN;

VN.X=V.X/v_length;
VN.Y=V.Y/v_length;

float D=C.X*VN.X+C.Y*VN.Y;

if (D<0)
	return -2;

float F_square=C_square-(D*D);

float sum_radi_square=sum_radi*sum_radi;

if (F_square>sum_radi_square)
	return -3;

float T_square=sum_radi_square-F_square;

D-=fsqrt(T_square);

if (D>v_length)
	return -4;

D/=v_length;

/*update the location of the two objects to the point where they touch*/

	current->position.X+=current->velocity.X*D;
	current->position.Y+=current->velocity.Y*D;

	target->position.X+=target->velocity.X*D;
	target->position.Y+=target->velocity.Y*D;

	target->collision=1;
	current->collision=1;

/*calculate bounce*/
/*normalizing the C vector*/

vector CN;

CN.X=target->position.X-current->position.X;
CN.Y=target->position.Y-current->position.Y;


float cn_length=fsqrt((CN.X*CN.X)+(CN.Y*CN.Y));

if(cn_length<=0.0000000f)
	v_length=0.0001;


CN.X/=cn_length;
CN.Y/=cn_length;

float a1=current->velocity.X*CN.X+current->velocity.Y*CN.Y;
float a2=target->velocity.X*CN.X+target->velocity.Y*CN.Y;

float optimizedP=(2.0f*(a1 - a2)) / sum_radi;

play_sfx(sound.mine_mine_hit, 255*optimizedP, pos2pan(current->position.X), g_point);

current->velocity.X-=(optimizedP * target->size * CN.X);
current->velocity.Y-=(optimizedP * target->size * CN.Y);

target->velocity.X += (optimizedP * current->size * CN.X);
target->velocity.Y += (optimizedP * current->size * CN.Y);

/*move them for the remainder of the frame along the new velocity vector*/

D=1.0f-D;

	current->position.X+=current->velocity.X*D;
	current->position.Y+=current->velocity.Y*D;

	target->position.X+=target->velocity.X*D;
	target->position.Y+=target->velocity.Y*D;

return 1;

}

